SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

Error subclass: #BookNotInCatalogException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Error subclass: #NotAValidQuantityException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'contents catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 21:28'!
withCatalog: aCollection 
	^Cart new initializeCatalogOn: aCollection! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 21:34'!
add: anISBN withQuantity: aNumber
	
	aNumber > 0 ifFalse: [NotAValidQuantityException new signal].
	(self isAListedISBN: anISBN) ifFalse: [BookNotInCatalogException new signal.].
	contents add: anISBN withOccurrences: aNumber.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 21:29'!
initializeCatalogOn: aCollection 
	catalog := aCollection.
	contents := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 21:30'!
isAListedISBN: anISBN  
	
	^catalog includes: anISBN.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/13/2012 21:32'!
isEmpty
	^contents isEmpty! !

!Cart methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/12/2012 19:11'!
listContents
	^ contents.! !

Object subclass: #Cashier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: 'marketplace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/13/2012 21:31'!
cart
	
	 ^self cartWith: #('book1' 'book2' 'book3')! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/13/2012 21:22'!
cartWith: aCollectionOfBooks
	
	^Cart withCatalog: aCollectionOfBooks.! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/13/2012 21:27'!
test01CartsAreCreatedEmpty
	self assert: (self cart isEmpty)! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/13/2012 21:33'!
test02CantAddBookNotInCatalogToCart
	| cart |
	cart := self cart.
	self should: [ cart add: 'notBook' withQuantity: 1 ] raise: BookNotInCatalogException.
	self assert: cart isEmpty.! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/13/2012 21:34'!
test03CantAddZeroOrNegativeNumberOfBooks
	| cart |
	cart := self cart.
	self should: [ cart add: 'book1' withQuantity: 0 ] raise: NotAValidQuantityException.
	self assert: cart listContents isEmpty.
	self should: [ cart add: 'book1' withQuantity: -1 ] raise: NotAValidQuantityException.
	self assert: cart listContents isEmpty! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/13/2012 21:35'!
test04ACanAddBookInCatalogue
	| cart list |
	cart := self cart.
	cart add: 'book1' withQuantity: 1.
	list := cart listContents.
	self assert: (list occurrencesOf: 'book1') = 1! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/13/2012 21:36'!
test04BCanAddMultipleBooksMultipleTimes
	| cart list |
	cart := self cart.
	cart add: 'book1' withQuantity: 1.
	cart add: 'book1' withQuantity: 3.
	cart add: 'book2' withQuantity: 2.
	list := cart listContents.
	self assert: (list occurrencesOf: 'book1') = 4.
	self assert: (list occurrencesOf: 'book2') = 2! !

!TusLibrosTest methodsFor: 'tests' stamp: 'RavasiAronson 6/13/2012 21:39'!
test05CantCheckoutEmptyCart
	
	Cashier checkout: self cart withCreditCard: self creditCard.! !
